#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define sgn(x)	(abs(x)/(x))

typedef struct vector
{
	int x;
	int y;
	int z;
} vector;

int N;
int celkem_poli;

int*** kostka;
int q,w,e,r,t,z,u,i,o,p,a,s,d,f,g,h,j,k,l,y,x,c,v,b,n,m;

void dump(void)
{
	int i,j,k;
	for (i=0;i<N;i++)
	{
		for (j=0;j<N;j++)
		{
			for (k=0;k<N;k++)
				printf("%d ",kostka[i][j][k]);
			printf("\n");
		}
		printf("---\n");
	}
}

int probe_path(vector now, vector move, int id, int fillness)
{
//	printf("%d %d %d -> %d %d %d; %d; %d\n",now.x, now.y, now.z, move.x,move.y,move.z, id, fillness);
	vector now_;
	vector move_;
	int q,w,e,r,t,z,u,i,o,p,a,s,d,f,g,h,j,k,l,y,x,c,v,b,n,m;
	r = 0;
	if (move.x != 0)
		for (i=1;i<=abs(move.x);i++)
			if (kostka[now.x + sgn(move.x)*i][now.y][now.z] != 0) return 0;
	if (move.y != 0)
		for (i=1;i<=abs(move.y);i++)
			if (kostka[now.x][now.y + sgn(move.y)*i][now.z] != 0) return 0;
	if (move.z != 0)
		for (i=1;i<=abs(move.z);i++)
			if (kostka[now.x][now.y][now.z + sgn(move.z)*i] != 0) return 0;

	if (move.x != 0)
		for (i=1;i<=abs(move.x);i++)
			kostka[now.x + sgn(move.x)*i][now.y][now.z] = id;
	if (move.y != 0)
		for (i=1;i<=abs(move.y);i++)
			kostka[now.x][now.y + sgn(move.y)*i][now.z] = id;
	if (move.z != 0)
		for (i=1;i<=abs(move.z);i++)
			kostka[now.x][now.y][now.z + sgn(move.z)*i] = id;

	if (fillness + abs(move.x) + abs(move.y) + abs(move.z) == celkem_poli)
	{
		dump();
		r = 1;
		move.x = 0;
		move.y = 0;
		move.z = 0;
	}
	now_.x = now.x + move.x;
	now_.y = now.y + move.y;
	now_.z = now.z + move.z;
	if (move.x != 0)
	{
		r = 0;
		move_.x = 0;
		move_.y = 0;
		move_.z = 0;
		for (i=0;i<N;i++)
		{
			if (abs(now.y - i) <= 1) continue;
			move_.y = i - now.y;
			r += probe_path(now_, move_, id+1, fillness + abs(move.x));
		}
		move_.y = 0;
		for (i=0;i<N;i++)
		{
			if (abs(now.z - i) <= 1) continue;
			now_.z = i - now.z;
			r += probe_path(now_, move_, id+1, fillness + abs(move.x));
		}
	}
	if (move.y != 0)
	{
		r = 0;
		move_.x = 0;
		move_.y = 0;
		move_.z = 0;
		for (i=0;i<N;i++)
		{
			if (abs(now.x - i) <= 1) continue;
			move_.x = i - now.x;
			r += probe_path(now_, move_, id+1, fillness + abs(move.y));
		}
		move_.x = 0;
		for (i=0;i<N;i++)
		{
			if (abs(now.z - i) <= 1) continue;
			now_.z = i - now.z;
			r += probe_path(now_, move_, id+1, fillness + abs(move.y));
		}
	}
	if (move.z != 0)
	{
		r = 0;
		move_.x = 0;
		move_.y = 0;
		move_.z = 0;
		for (i=0;i<N;i++)
		{
			if (abs(now.y - i) <= 1) continue;
			move_.y = i - now.y;
			r += probe_path(now_, move_, id+1, fillness + abs(move.z));
		}
		move_.y = 0;
		for (i=0;i<N;i++)
		{
			if (abs(now.x - i) <= 1) continue;
			now_.x = i - now.x;
			r += probe_path(now_, move_, id+1, fillness + abs(move.z));
		}
	}
	if (move.x != 0)
		for (i=1;i<=abs(move.x);i++)
			kostka[now.x + sgn(move.x)*i][now.y][now.z] = 0;
	if (move.y != 0)
		for (i=1;i<=abs(move.y);i++)
			kostka[now.x][now.y + sgn(move.y)*i][now.z] = 0;
	if (move.z != 0)
		for (i=1;i<=abs(move.z);i++)
			kostka[now.x][now.y][now.z + sgn(move.z)*i] = 0;
//	printf("%d\n",r);
	return r;
	
}
vector now, move;

int main(int argc, char ** argv)
{
	N = atoi(argv[1]);
	celkem_poli = N*N*N;
	
	kostka = malloc(sizeof(int **)*N);
	for (i=0;i<N;i++)
	{
		kostka[i] = malloc(sizeof(int *)*N);
		for (j=0;j<N;j++)
			kostka[i][j] = malloc(sizeof(int)*N);
	}
	kostka[0][0][0] = 1;
	now.x = 0;
	now.y = 0;
	now.z = 0;
	move.x = N-1;
	move.y = 0;
	move.z = 0;
	m = probe_path(now, move, 2, 1);
	if (m == 0)
	{
		printf("Nebylo nalezeno žádné vyplnění.\n");
	}
	else
	{
		printf("Celkový počet nalezených vyplnění je %d.\n",m);
	}
}
