#!/usr/bin/env python
from xml.dom import minidom
from xml.dom import ext
import sys
import math

def number_normalize(number):
	pole = number.split("/")
	if (len(pole) == 1):
		return float(pole[0])
	else:
		return float(pole[0])/float(pole[1])

def func_change(function, number):
	x = number
	return eval(function)

xmlfile = minidom.parse(sys.argv[1])
#print xmlfile.toxml()

fields = {}

for item in xmlfile.getElementsByTagName("q"):
	question = {}
	sub_fields = []
#	print ""
#	print item.getElementsByTagName("n")[0].childNodes[0].toxml()
	for sub_item in item.getElementsByTagName("a"):
		answer = {}
#		print "\t" + sub_item.getElementsByTagName("n")[0].childNodes[0].toxml()
#		print "\t" + sub_item.getElementsByTagName("f")[0].childNodes[0].toxml()
#		print ""
		answer['number'] = number_normalize(sub_item.getElementsByTagName("n")[0].childNodes[0].toxml())
		answer['function'] = sub_item.getElementsByTagName("f")[0].childNodes[0].toxml()
		sub_fields.append(answer)
	
	question['answers'] = sub_fields;
	question['number'] = number_normalize(item.getElementsByTagName("n")[0].childNodes[0].toxml())
	fields[question['number']] = question

states_waiting = {}
states_done = {}
states_all = {}

state = {}
state['field'] = fields[1.0]
state['function'] = u'x'
state['preceeding'] = {}
index = state['field']['number'],state['function']
#print index
states_all[index] = state
states_waiting[index] = state

while len(states_waiting) > 0:
	state = states_waiting.pop(states_waiting.keys()[0])
#	print state
#	print 
	function = state['function']
	field_number = state['field']['number']
	states_done[(field_number,function)] = state
	state['following'] = {}
	for field_answer in state['field']['answers']:
		number = field_answer['number']
		function_new = field_answer['function']
		state_new = {}
		state_new['field'] = fields[round(func_change(function,number)*3)/3]
		state_new['function'] = function_new
		state_new['preceeding'] = {}
		state_new['preceeding'][(field_number,function)] = 1
		index = state_new['field']['number'],state_new['function']
		if states_done.has_key(index):
			states_done[index]['preceeding'][(field_number,function)] = 1
			states_all[index]['preceeding'][(field_number,function)] = 1
			pass
		else:
			if states_all.has_key(index):
				pass
			else:
				states_waiting[index] = state_new
				states_all[index] = state_new

			states_waiting[index]['preceeding'][(field_number,function)] = 1
			states_all[index]['preceeding'][(field_number,function)] = 1
		state['following'][(state_new['field']['number'],function_new)] = 1

		
#print "rrrr"
#print states_all
for index in states_all.keys():
#	print index
	state = states_all[index]
	print (state['field']['number'], state['function'])
	for ehm in state['preceeding']:
		print "\tFrom:", ehm
	print
	for ehm in state['following']:
		print "\tTo:", ehm
	print ""

